(in-package "MAXIMA")

;; See if E matches the pattern c*(a+b*u^2)^n.  If so, return
;; the maxima list [a, b, c, n]
(defun $id_type3_match (e var)
  (declare (special var))
  (let* ((pat
	  ;; Pattern should be c*(a+b*u^2)^n where a, b, c
	  ;; don't contain u and n is a number.
	  '((mtimes) (c freevar)
	    ((mexpt)
	     ((mplus) ((coeffpp) (a freevar))
	      ((mtimes) ((coefftt) (b freevar))
	       ((mexpt) (var varp) 2)))
	     (n numberp))))
	 (match1 (m2 e pat nil))
	 (match2 (unless match1
		   (m2 (mul -1 e) pat nil)))
	 (match (or match1 match2)))
    (when (or match1 match2)
      (list '(mlist)
	    (cdr (assoc 'a match))
	    (cdr (assoc 'b match))
	    (mul (if match1 1 -1)
		 (cdr (assoc 'c match)))
	    (cdr (assoc 'n match))))))
